# Generated by Django 4.2.11 on 2024-06-07 09:19

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import pgvector.django
import uuid


class Migration(migrations.Migration):
    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ("api", "0001_create_vector"),
    ]

    operations = [
        migrations.CreateModel(
            name="Chat",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                        unique=True,
                    ),
                ),
                ("title", models.CharField(max_length=99)),
                ("is_default", models.BooleanField(default=False)),
                ("origin_id", models.CharField(max_length=99)),
            ],
        ),
        migrations.CreateModel(
            name="Contact",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                        unique=True,
                    ),
                ),
                ("origin", models.CharField(max_length=99)),
                ("inserted_at", models.DateTimeField(auto_now=True)),
                ("internal", models.BooleanField(blank=True, default=True, null=True)),
            ],
        ),
        migrations.CreateModel(
            name="Dataset",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(default="", max_length=50)),
                (
                    "description",
                    models.TextField(
                        default="", help_text="User describes the conversation domain"
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="GuardrailAction",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                        unique=True,
                    ),
                ),
                (
                    "action_type",
                    models.CharField(
                        choices=[
                            ("scripted", "Scripted"),
                            ("generative", "Generative"),
                        ],
                        help_text="GuardrailAction",
                        max_length=100,
                    ),
                ),
                ("content", models.TextField()),
            ],
        ),
        migrations.CreateModel(
            name="Message",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                        unique=True,
                    ),
                ),
                (
                    "direction",
                    models.CharField(
                        choices=[("inbound", "Inbound"), ("outbound", "Outbound")],
                        max_length=99,
                    ),
                ),
                (
                    "sender_type",
                    models.CharField(
                        choices=[
                            ("bot", "Bot"),
                            ("user", "User"),
                            ("operator", "Operator"),
                        ],
                        max_length=99,
                    ),
                ),
                (
                    "channel_type",
                    models.CharField(
                        choices=[("web", "Web"), ("facebook", "Facebook")],
                        max_length=99,
                    ),
                ),
                ("timestamp", models.DateTimeField(auto_now=True)),
                ("text", models.TextField()),
                (
                    "embedding",
                    pgvector.django.VectorField(
                        blank=True, default=None, dimensions=384, null=True
                    ),
                ),
                (
                    "chat",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="api.chat",
                    ),
                ),
                (
                    "contact",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="api.contact"
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="MessageTagDefinition",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                        unique=True,
                    ),
                ),
                ("name", models.CharField(max_length=50)),
                ("description", models.CharField(max_length=255)),
            ],
        ),
        migrations.CreateModel(
            name="MLModel",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                (
                    "sklearn_pipeline",
                    models.BinaryField(
                        blank=True,
                        default=None,
                        help_text="Sklearn logistic regression or SVM etc",
                        null=True,
                    ),
                ),
                ("name", models.CharField(default="", max_length=50)),
                (
                    "description",
                    models.TextField(default="", help_text="Description for model"),
                ),
                (
                    "status",
                    models.CharField(
                        choices=[
                            ("up-to-date", "Up To Date"),
                            ("needs-retraining", "Needs Retraining"),
                            ("training", "Training"),
                        ],
                        default="up-to-date",
                        help_text="The state of processing and working with a MLModel instance",
                        max_length=16,
                    ),
                ),
                (
                    "created_by",
                    models.ForeignKey(
                        default=None,
                        on_delete=django.db.models.deletion.CASCADE,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "dataset",
                    models.ForeignKey(
                        blank=True,
                        default=None,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="api.dataset",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="Project",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                        unique=True,
                    ),
                ),
                ("name", models.CharField(max_length=50)),
                ("digest", models.CharField(max_length=128, unique=True)),
                ("token_key", models.CharField(max_length=15)),
                (
                    "owner",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="ProjectCollaborator",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "verification_status",
                    models.CharField(
                        choices=[
                            ("V", "Verified"),
                            ("U", "Unverified"),
                            ("E", "Expired"),
                        ],
                        default="U",
                        help_text="The status of a potential team member's user account activation",
                        max_length=1,
                    ),
                ),
                (
                    "role",
                    models.CharField(
                        choices=[("V", "Viewer"), ("E", "Editor"), ("O", "Owner")],
                        default="V",
                        help_text="The permission level for a team member in a project",
                        max_length=1,
                    ),
                ),
                ("properties", models.JSONField(default=dict)),
                (
                    "delvin_user",
                    models.ForeignKey(
                        blank=True,
                        help_text="A Delvin user account",
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "project",
                    models.ForeignKey(
                        help_text="A Delvin project",
                        on_delete=django.db.models.deletion.CASCADE,
                        to="api.project",
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="MLWeights",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "coef",
                    pgvector.django.VectorField(
                        default=[
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                            0.0,
                        ],
                        dimensions=384,
                    ),
                ),
                ("intercept", models.FloatField(default=0.0)),
                (
                    "ml_model",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="api.mlmodel"
                    ),
                ),
                (
                    "tag_definition",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="api.messagetagdefinition",
                    ),
                ),
            ],
        ),
        migrations.AddField(
            model_name="mlmodel",
            name="project",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE, to="api.project"
            ),
        ),
        migrations.CreateModel(
            name="MessageTagRule",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                        unique=True,
                    ),
                ),
                (
                    "direction",
                    models.CharField(
                        choices=[
                            ("inbound", "Inbound"),
                            ("outbound", "Outbound"),
                            ("any", "Any"),
                        ],
                        max_length=99,
                    ),
                ),
                (
                    "rule_type",
                    models.CharField(
                        choices=[
                            ("contains", "Contains"),
                            ("not_contains", "Not Contains"),
                        ],
                        max_length=99,
                    ),
                ),
                ("rule_content", models.JSONField()),
                (
                    "message_tag_definition",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="api.messagetagdefinition",
                    ),
                ),
                (
                    "project",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="api.project"
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="MessageTagGroup",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                        unique=True,
                    ),
                ),
                ("name", models.CharField(max_length=50)),
                (
                    "project",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="api.project"
                    ),
                ),
            ],
        ),
        migrations.AddField(
            model_name="messagetagdefinition",
            name="message_tag_group",
            field=models.ForeignKey(
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                to="api.messagetaggroup",
            ),
        ),
        migrations.AddField(
            model_name="messagetagdefinition",
            name="project",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE, to="api.project"
            ),
        ),
        migrations.CreateModel(
            name="MessageTag",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                (
                    "labeler",
                    models.ForeignKey(
                        blank=True,
                        default=None,
                        help_text="Labeler of tagged message, if set to null machine is labeler",
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "message",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="api.message"
                    ),
                ),
                (
                    "ml_model",
                    models.ForeignKey(
                        blank=True,
                        default=None,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="api.mlmodel",
                    ),
                ),
                (
                    "tag",
                    models.ForeignKey(
                        help_text="Predicted intent tag for a text message, created by either a human or an MLModel.",
                        on_delete=django.db.models.deletion.CASCADE,
                        to="api.messagetagdefinition",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.AddField(
            model_name="message",
            name="project",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE, to="api.project"
            ),
        ),
        migrations.AddField(
            model_name="message",
            name="tags",
            field=models.ManyToManyField(
                through="api.MessageTag", to="api.messagetagdefinition"
            ),
        ),
        migrations.CreateModel(
            name="GuardrailResponse",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                        unique=True,
                    ),
                ),
                (
                    "guardrail_action",
                    models.ForeignKey(
                        help_text="Will be used as action type and content text",
                        on_delete=django.db.models.deletion.CASCADE,
                        to="api.guardrailaction",
                    ),
                ),
                (
                    "message_tag_definition",
                    models.ForeignKey(
                        help_text="Will be used as response trigger",
                        on_delete=django.db.models.deletion.CASCADE,
                        to="api.messagetagdefinition",
                    ),
                ),
                (
                    "project",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="api.project"
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="Document",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "title",
                    models.CharField(
                        default="",
                        help_text="A unique name for the information",
                        max_length=100,
                    ),
                ),
                (
                    "content",
                    models.TextField(
                        help_text="The information that the chatbot should use to answer questions"
                    ),
                ),
                (
                    "status",
                    models.CharField(
                        choices=[
                            ("C", "Created"),
                            ("U", "Updated"),
                            ("P", "Processed"),
                            ("E", "Error"),
                            ("D", "Deleted"),
                        ],
                        default="C",
                        help_text="The state of processing and working with a Document instance",
                        max_length=1,
                    ),
                ),
                (
                    "project",
                    models.ForeignKey(
                        help_text="The project the Document was uploaded to",
                        on_delete=django.db.models.deletion.CASCADE,
                        to="api.project",
                    ),
                ),
            ],
        ),
        migrations.AddField(
            model_name="dataset",
            name="project",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE, to="api.project"
            ),
        ),
        migrations.AddField(
            model_name="contact",
            name="project",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE, to="api.project"
            ),
        ),
        migrations.CreateModel(
            name="Chatbot",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "generative_model",
                    models.CharField(
                        choices=[
                            ("openai/gpt-3.5-turbo", "Openai Gpt Turbo"),
                            ("mistralai/mistral-7b-instruct", "Mistral 7B Instruct"),
                        ],
                        default="mistralai/mistral-7b-instruct",
                        help_text="The generative model used by the chatbot to generate responses",
                        max_length=99,
                    ),
                ),
                ("description", models.TextField(default="")),
                (
                    "generation_parameters",
                    models.JSONField(
                        default=dict,
                        help_text="Generation parameters sent to LLM according to which it's got more precise and relevant responses",
                    ),
                ),
                (
                    "active_chat",
                    models.ForeignKey(
                        blank=True,
                        help_text="Currently active chat session with message history",
                        null=True,
                        on_delete=django.db.models.deletion.RESTRICT,
                        to="api.chat",
                    ),
                ),
                (
                    "project",
                    models.OneToOneField(
                        on_delete=django.db.models.deletion.CASCADE, to="api.project"
                    ),
                ),
            ],
        ),
        migrations.AddField(
            model_name="chat",
            name="contact_id",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE, to="api.contact"
            ),
        ),
    ]
